Loading...
Searching...
No Matches
dolfin::HexahedronCell Class Reference

This class implements functionality for hexahedral cell meshes. More...

`#include <HexahedronCell.h>`

Inheritance diagram for dolfin::HexahedronCell:
[legend]
Collaboration diagram for dolfin::HexahedronCell:
[legend]

## Public Member Functions

| HexahedronCell ()
| Specify cell type and facet type.
bool | is_simplex () const
| Check if cell is a simplex.
std::size_t | dim () const
| Return topological dimension of cell.
std::size_t | num_entities (std::size_t dim) const
| Return number of entities of given topological dimension.
std::size_t | num_vertices (std::size_t dim) const
| Return number of vertices for entity of given topological dimension.
std::size_t | orientation (const Cell &cell) const
| Return orientation of the cell.
void | create_entities (boost::multi_array< unsigned int, 2 > &e, std::size_t dim, const unsigned int *v) const
| Create entities e of given topological dimension from vertices v.
double | volume (const MeshEntity &triangle) const
| Compute (generalized) volume (area) of triangle.
double | circumradius (const MeshEntity &triangle) const
| Compute diameter of triangle.
double | squared_distance (const Cell &cell, const Point &point) const
| Compute squared distance to given point (3D enabled).
double | normal (const Cell &cell, std::size_t facet, std::size_t i) const
| Compute component i of normal of given facet with respect to the cell.
Point | normal (const Cell &cell, std::size_t facet) const
| Compute of given facet with respect to the cell.
Point | cell_normal (const Cell &cell) const
| Compute normal to given cell (viewed as embedded in 3D).
double | facet_area (const Cell &cell, std::size_t facet) const
| Compute the area/length of given facet with respect to the cell.
void | order (Cell &cell, const std::vector< std::int64_t > &local_to_global_vertex_indices) const
| Order entities locally.
bool | collides (const Cell &cell, const Point &point) const
| Check whether given point collides with cell.
bool | collides (const Cell &cell, const MeshEntity &entity) const
| Check whether given entity collides with cell.
std::string | description (bool plural) const
| Return description of cell type.
std::vector< std::int8_t > | vtk_mapping () const
| Mapping of DOLFIN/UFC vertex ordering to VTK/XDMF ordering.
Public Member Functions inherited from dolfin::CellType
| CellType (Type cell_type, Type facet_type)
| Constructor.
virtual | ~CellType ()
| Destructor.
Type | cell_type () const
| Return type of cell.
Type | facet_type () const
| Return type of cell for facets.
Type | entity_type (std::size_t i) const
| Return type of cell for entity of dimension i.
std::size_t | num_vertices () const
| Return number of vertices for cell.
std::size_t | orientation (const Cell &cell, const Point &up) const
| Return orientation of the cell relative to given up direction.
virtual double | h (const MeshEntity &entity) const
| Compute greatest distance between any two vertices.
virtual double | inradius (const Cell &cell) const
| Compute inradius of cell.
virtual double | radius_ratio (const Cell &cell) const
| Compute dim*inradius/circumradius for given cell.
bool | ordered (const Cell &cell, const std::vector< std::int64_t > &local_to_global_vertex_indices) const
| Check if entities are ordered.

## Additional Inherited Members

Public Types inherited from dolfin::CellType
enum class | Type : int { point , interval , triangle , quadrilateral , tetrahedron , hexahedron }
| Enum for different cell types.
Static Public Member Functions inherited from dolfin::CellType
static CellType * | create (Type type)
| Create cell type from type (factory function).
static CellType * | create (std::string type)
| Create cell type from string (factory function).
static Type | string2type (std::string type)
| Convert from string to cell type.
static std::string | type2string (Type type)
| Convert from cell type to string.
Static Protected Member Functions inherited from dolfin::CellType
static void | sort_entities (std::size_t num_vertices, unsigned int *vertices, const std::vector< std::int64_t > &local_to_global_vertex_indices)
| Sort vertices based on global entity indices.
Protected Attributes inherited from dolfin::CellType
Type | _cell_type
Type | _facet_type

## Detailed Description

This class implements functionality for hexahedral cell meshes.

## Member Function Documentation

## cell_normal()

Point HexahedronCell::cell_normal | ( | const Cell & | cell | ) | const

virtual

Compute normal to given cell (viewed as embedded in 3D).

Implements dolfin::CellType.

## circumradius()

double HexahedronCell::circumradius | ( | const MeshEntity & | triangle | ) | const

virtual

Compute diameter of triangle.

Implements dolfin::CellType.

## collides() [1/2]

bool HexahedronCell::collides | ( | const Cell & | cell,
|  | const MeshEntity & | entity ) const

virtual

Check whether given entity collides with cell.

Implements dolfin::CellType.

## collides() [2/2]

bool HexahedronCell::collides | ( | const Cell & | cell,
|  | const Point & | point ) const

virtual

Check whether given point collides with cell.

Implements dolfin::CellType.

## create_entities()

void HexahedronCell::create_entities | ( | boost::multi_array< unsigned int, 2 > & | e,
|  | std::size_t | dim,
|  | const unsigned int * | v ) const

virtual

Create entities e of given topological dimension from vertices v.

Implements dolfin::CellType.

## description()

std::string HexahedronCell::description | ( | bool | plural | ) | const

virtual

Return description of cell type.

Implements dolfin::CellType.

## dim()

std::size_t HexahedronCell::dim | ( |  | ) | const

virtual

Return topological dimension of cell.

Implements dolfin::CellType.

## facet_area()

double HexahedronCell::facet_area | ( | const Cell & | cell,
|  | std::size_t | facet ) const

virtual

Compute the area/length of given facet with respect to the cell.

Implements dolfin::CellType.

## is_simplex()

bool dolfin::HexahedronCell::is_simplex | ( |  | ) | const

inline virtual

Check if cell is a simplex.

Implements dolfin::CellType.

## normal() [1/2]

Point HexahedronCell::normal | ( | const Cell & | cell,
|  | std::size_t | facet ) const

virtual

Compute of given facet with respect to the cell.

Implements dolfin::CellType.

## normal() [2/2]

double HexahedronCell::normal | ( | const Cell & | cell,
|  | std::size_t | facet,
|  | std::size_t | i ) const

virtual

Compute component i of normal of given facet with respect to the cell.

Implements dolfin::CellType.

## num_entities()

std::size_t HexahedronCell::num_entities | ( | std::size_t | dim | ) | const

virtual

Return number of entities of given topological dimension.

Implements dolfin::CellType.

## num_vertices()

std::size_t HexahedronCell::num_vertices | ( | std::size_t | dim | ) | const

virtual

Return number of vertices for entity of given topological dimension.

Implements dolfin::CellType.

## order()

void HexahedronCell::order | ( | Cell & | cell,
|  | const std::vector< std::int64_t > & | local_to_global_vertex_indices ) const

virtual

Order entities locally.

Implements dolfin::CellType.

## orientation()

std::size_t HexahedronCell::orientation | ( | const Cell & | cell | ) | const

virtual

Return orientation of the cell.

Implements dolfin::CellType.

## squared_distance()

double HexahedronCell::squared_distance | ( | const Cell & | cell,
|  | const Point & | point ) const

virtual

Compute squared distance to given point (3D enabled).

Implements dolfin::CellType.

## volume()

double HexahedronCell::volume | ( | const MeshEntity & | triangle | ) | const

virtual

Compute (generalized) volume (area) of triangle.

Implements dolfin::CellType.

## vtk_mapping()

std::vector< std::int8_t > dolfin::HexahedronCell::vtk_mapping | ( |  | ) | const

inline virtual

Mapping of DOLFIN/UFC vertex ordering to VTK/XDMF ordering.

Implements dolfin::CellType.

The documentation for this class was generated from the following files:

- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/mesh/HexahedronCell.h
- /build/dolfin-wwk1CC/dolfin-2019.2.0~legacy20240219.1c52e83/dolfin/mesh/HexahedronCell.cpp